package com.qmth.ops.api.controller.ai;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.core.ai.model.AiConstants;
import com.qmth.boot.core.ai.model.ocr.OcrType;
import com.qmth.boot.tools.signature.SignatureType;
import com.qmth.ops.api.security.AccessOrg;
import com.qmth.ops.biz.service.OcrClientService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestAttribute;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;

@RestController
@Aac(auth = true, signType = SignatureType.SECRET)
public class OcrController {

    @Resource
    private OcrClientService ocrClientService;

    @PostMapping(AiConstants.OCR_IMAGE_PATH)
    public String forImage(@RequestAttribute AccessOrg accessOrg, @RequestParam("type") OcrType type,
            @RequestParam("image") MultipartFile file) throws Exception {
        return ocrClientService.forImage(type, file.getBytes());
    }

}
