package com.qmth.ops.biz.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.ops.biz.dao.AppDao;
import com.qmth.ops.biz.domain.App;
import com.qmth.ops.biz.query.AppQuery;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service
public class AppService extends ServiceImpl<AppDao, App> {

    @Resource
    private AppDao appDao;

    @Transactional
    public App insert(App app) {
        app.setCreateTime(System.currentTimeMillis());
        app.setUpdateTime(app.getCreateTime());
        appDao.insert(app);
        return app;
    }

    @Transactional
    public void update(App app) {
        appDao.update(app, new LambdaUpdateWrapper<App>().set(app.getCode() != null, App::getCode, app.getCode())
                .set(app.getName() != null, App::getName, app.getName())
                .set(App::getUpdateTime, System.currentTimeMillis()).eq(App::getId, app.getId()));
    }

    public IPage<App> query(AppQuery query) {
        return this.page(query, query.buildQuery());
    }

    public List<App> list(AppQuery query) {
        return this.list(query.buildQuery());
    }

    public App findByCode(String code) {
        return appDao.selectOne(new LambdaQueryWrapper<App>().eq(App::getCode, code));
    }
}

