package com.qmth.ops.biz.service;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.ops.biz.dao.LlmModelDao;
import com.qmth.ops.biz.domain.LlmModel;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service
public class LlmModelService extends ServiceImpl<LlmModelDao, LlmModel> {

    @Resource
    private LlmModelDao modelDao;

    @Transactional
    public LlmModel insert(LlmModel model) {
        model.setCreateTime(System.currentTimeMillis());
        model.setUpdateTime(model.getCreateTime());
        modelDao.insert(model);
        return model;
    }

    @Transactional
    public void update(LlmModel model) {
        modelDao.update(model,
                new LambdaUpdateWrapper<LlmModel>().set(model.getName() != null, LlmModel::getName, model.getName())
                        .set(model.getQpm() != null, LlmModel::getQpm, model.getQpm())
                        .set(model.getTpm() != null, LlmModel::getTpm, model.getTpm())
                        .set(LlmModel::getUpdateTime, System.currentTimeMillis()).eq(LlmModel::getId, model.getId()));
    }

    public List<LlmModel> listBySupplier(Long supplierId) {
        return modelDao.selectList(new LambdaUpdateWrapper<LlmModel>().eq(LlmModel::getSupplierId, supplierId));
    }

}

