package com.qmth.ops.biz.service;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.ops.biz.dao.LlmSupplierDao;
import com.qmth.ops.biz.domain.LlmSupplier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service
public class LlmSupplierService extends ServiceImpl<LlmSupplierDao, LlmSupplier> {

    @Resource
    private LlmSupplierDao supplierDao;

    @Transactional
    public LlmSupplier insert(LlmSupplier supplier) {
        supplier.setCreateTime(System.currentTimeMillis());
        supplier.setUpdateTime(supplier.getCreateTime());
        supplierDao.insert(supplier);
        return supplier;
    }

    @Transactional
    public void update(LlmSupplier supplier) {
        supplierDao.update(supplier, new LambdaUpdateWrapper<LlmSupplier>()
                .set(supplier.getName() != null, LlmSupplier::getName, supplier.getName())
                .set(supplier.getUrl() != null, LlmSupplier::getUrl, supplier.getUrl())
                .set(supplier.getSecret() != null, LlmSupplier::getSecret, supplier.getSecret())
                .set(LlmSupplier::getUpdateTime, System.currentTimeMillis()).eq(LlmSupplier::getId, supplier.getId()));
    }

    public List<LlmSupplier> list() {
        return supplierDao.selectList(new LambdaUpdateWrapper<>());
    }

}

