package com.qmth.ops.biz.service;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.ops.biz.dao.OcrSupplierDao;
import com.qmth.ops.biz.domain.OcrSupplier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

@Service
public class OcrSupplierService extends ServiceImpl<OcrSupplierDao, OcrSupplier> {

    @Resource
    private OcrSupplierDao supplierDao;

    @Transactional
    public OcrSupplier insert(OcrSupplier supplier) {
        supplier.setCreateTime(System.currentTimeMillis());
        supplier.setUpdateTime(supplier.getCreateTime());
        supplierDao.insert(supplier);
        return supplier;
    }

    @Transactional
    public void update(OcrSupplier supplier) {
        supplierDao.update(supplier, new LambdaUpdateWrapper<OcrSupplier>()
                .set(supplier.getName() != null, OcrSupplier::getName, supplier.getName())
                .set(supplier.getUrl() != null, OcrSupplier::getUrl, supplier.getUrl())
                .set(supplier.getKey() != null, OcrSupplier::getKey, supplier.getKey())
                .set(supplier.getSecret() != null, OcrSupplier::getSecret, supplier.getSecret())
                .set(supplier.getQps() != null, OcrSupplier::getQps, supplier.getQps())
                .set(supplier.getEnable() != null, OcrSupplier::getEnable, supplier.getEnable())
                .set(OcrSupplier::getUpdateTime, System.currentTimeMillis()).eq(OcrSupplier::getId, supplier.getId()));
    }

}

